/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2007 Ruslan P. Sorokin (sorokin@oogis.ru)
 * and Object-Oriented Geo-Information System Research Laboratory (http://www.oogis.ru)
 * All Rights Reserved.
 */
package ru.oogis.dro;

import java.awt.Component;
import java.awt.GridLayout;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.model.Instance;
import edu.stanford.smi.protege.ui.InstanceField;
import edu.stanford.smi.protege.util.CollectionUtilities;

public class Context {
	
	private static final long serialVersionUID = 1L;
	
	private static Map<Object, Component> map3;
	
	private static JPanel getPanel(Map<Object, Object> map2){
		JPanel panel = new JPanel();
		int size = map2.size();
		if(size < 11)
			panel.setLayout(new GridLayout(size,1));
		else
			panel.setLayout(new GridLayout(size/2+1,2));
		Component comp;
		map3 = new HashMap<Object, Component>();
		Set<Object> set = map2.keySet();
		for (Iterator<Object> iter = set.iterator(); iter.hasNext();) {
			Object var = iter.next();
			Object val = map2.get(var);
			if(val instanceof Instance)
			{
				comp = newInstanceField(var, (Instance) val);
			}
			else
			{
				comp = new Context().new ObjectField(var, val);
			}
			panel.add(comp);
			map3.put(var, comp);
		}
		return panel;
	}
	
	private static InstanceField newInstanceField(Object name, Instance ins)
	{
		Cls cls = ins.getDirectType();
		InstanceField infi = new InstanceField((String)name,CollectionUtilities.createCollection(cls));
		infi.setInstance(ins);
		infi.createSelectInstanceAction();
		infi.createRemoveInstanceAction();
		return infi;
	}
	
	class ObjectField extends JPanel
	{
		private static final long serialVersionUID = 1L;
		
		JTextField field;

		public ObjectField(Object name, Object value)
		{
			super();
			setLayout(new GridLayout(2,1));
			add(new JLabel((String) name));
			field = new JTextField(value.toString());
			add(field);
		}
	}
	
	public static void update(Map<Object, Object> map, String header1, String header2){
		if(!map.isEmpty())
		{
			boolean fill = DroolsTab.showModal(header1, getPanel(map), header2);
			if(fill)
			{
				Set<Object> set = map3.keySet();
				for (Iterator<Object> iter = set.iterator(); iter.hasNext();) {
					Object var = iter.next();
					Object comp = map3.get(var);
					if(comp instanceof InstanceField)
						map.put(var, ((InstanceField)comp).getInstance());
					else
						map.put(var, ((ObjectField)comp).field.getText());
				}
			}
		}
	}
	
}
