/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * Copyright (C) 2007 Ruslan P. Sorokin (sorokin@oogis.ru)
 * and Object-Oriented Geo-Information System Research Laboratory (http://www.oogis.ru)
 * All Rights Reserved.
 */
package ru.oogis.dro;

import java.util.Map;

import ru.oogis.util.OntoJava;
import edu.stanford.smi.protege.model.Instance;

public class ProtegeInstance {

	public Instance instance;
	@SuppressWarnings("unchecked")
	public Map ctxmap;
	
	public Instance getInstance() {
		return instance;
	}
	public void setInstance(Instance instance) {
		this.instance = instance;
	}
	public String toString(){
		String classname = this.getClass().getName();
		// delete package name
		int lio = classname.lastIndexOf('.');
		if(lio >= 0)
			classname = classname.substring(lio + 1);
		return classname;
	}
	public String toExtendedString(){
		String classname = this.getClass().getName();
		// delete package name
		int lio = classname.lastIndexOf('.');
		if(lio >= 0)
			classname = classname.substring(lio + 1);
		return classname+"\n"+OntoJava.TAB+"instance "+instance+"\n ctxmap "+ctxmap+"\n";
	}
	@SuppressWarnings("unchecked")
	public Map getCtxmap() {
		return ctxmap;
	}
	@SuppressWarnings("unchecked")
	public void setCtxmap(Map ctxmap) {
		this.ctxmap = ctxmap;
	}
}
