/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * WorkingMemoryInspector.java
 *
 * Created on 17.02.2010, 13:15:33
 */
package ru.oogis.dro;

import edu.stanford.smi.protege.model.Instance;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import org.drools.ClassObjectFilter;
import org.drools.WorkingMemory;
import org.drools.common.DefaultFactHandle;

/**
 *
 * @author ru
 */
public class WorkingMemoryInspector extends javax.swing.JPanel {

    private WorkingMemory wm;
    private Instance wmi;
    Collection<String> fnames;
    Boolean sort;
    private Vector obs;

    /** Creates new form WorkingMemoryInspector */
    public WorkingMemoryInspector(WorkingMemory wm, Instance wmi) {
        initComponents();
        this.wm = wm;
        this.wmi = wmi;
        fnames = wmi.getOwnSlotValues(KB.s_display_fields);
        sort = (Boolean) wmi.getOwnSlotValue(KB.s_sort);
        DefaultListModel dlm = new DefaultListModel();
        for (Iterator i = wm.iterateObjects(); i.hasNext();) {
            Class cls = i.next().getClass();
            if (!dlm.contains(cls)) {
                dlm.addElement(cls);
            }
        }
        jList1.setModel(dlm);
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent event){
                try {
                    displaySelectedRow();
                } catch (Exception ex) {
                    Logger.getLogger(WorkingMemoryInspector.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
        jSplitPane1.setResizeWeight(0.25);
        jSplitPane1.setOneTouchExpandable(true);
    }

    private void displaySelectedRow() throws Exception{
        if(obs!=null){
            int row = jTable1.getSelectedRow();
            if(row>=0){
                DroolsTab.displayObject(obs.elementAt(jTable1.getSelectedRow()), null);
            }
        }
    }

    private DefaultTableModel createTable(Class cls) throws Exception{
        Collection<Field> flds = new ArrayList<Field>();
        for (String fname : fnames) {
            try {
                flds.add(cls.getField(fname));
            } catch (Exception e) {
            }
        }
        Vector nvec = new Vector();
        for (Field fld: flds) {
            nvec.add(fld.getName());
        }
        nvec.add(0, "fact-id");
        obs = new Vector();
        Vector vvec = new Vector();
        ClassObjectFilter cof = new ClassObjectFilter(cls);
        if (sort) {
                List objects = new ArrayList();
                for (Iterator iter = wm.iterateObjects(cof); iter.hasNext();) {
                        objects.add(iter.next());
                }
                Collections.sort(objects, new PClassComparator());
                for (Iterator iter = objects.iterator(); iter.hasNext();) {
                        Object object = iter.next();
                        DefaultFactHandle fhandle = (DefaultFactHandle) wm.getFactHandle(object);
                        obs.add(object);
                        vvec.add(dataVector(object, flds, fhandle));
                }
        } else {
                List fhandles = new ArrayList();
                for (Iterator iter = wm.iterateFactHandles(cof); iter.hasNext();) {
                        fhandles.add(iter.next());
                }
                Collections.sort(fhandles, new FactHandleComparator());
                for (Iterator iter = fhandles.iterator(); iter.hasNext();) {
                        DefaultFactHandle fhandle = (DefaultFactHandle)iter.next();
                        Object object = fhandle.getObject();
                        obs.add(object);
                        vvec.add(dataVector(object, flds, fhandle));
                }
        }
        return new DefaultTableModel(vvec, nvec);
    }

    private Vector dataVector(Object obj, Collection<Field> flds, DefaultFactHandle fh) throws Exception{
        Vector vv = new Vector();
        if(obj instanceof String || obj instanceof Number)
            vv.add(obj);
        else
            for (Field fld: flds) {
                vv.add(fld.get(obj));
            }
        vv.add(0, fh.getId());
        return vv;
    }

    @SuppressWarnings("unchecked")
    class FactHandleComparator implements Comparator {

        public int compare(Object obj, Object obj1) {
            long recency = ((DefaultFactHandle) obj).getRecency();
            long recency1 = ((DefaultFactHandle) obj1).getRecency();
            return (recency < recency1 ? -1 : (recency == recency1 ? 0 : 1));
        }
    }
    @SuppressWarnings("unchecked")
    class PClassComparator implements Comparator {

        public int compare(Object obj, Object obj1) {
            if (obj instanceof String && obj1 instanceof String) {
                return ((String) obj).compareTo((String) obj1);
            } else if (obj instanceof Number && obj1 instanceof Number) {
                if( ((Number) obj).floatValue() < ((Number) obj1).floatValue() )
                    return -1;
                else if( ((Number) obj).floatValue() == ((Number) obj1).floatValue() )
                    return 0;
                else
                    return 1;
            } else {
                Class cls = obj.getClass();
                Field fld = null;
                for (String fname : fnames) {
                    try {
                        fld = cls.getField(fname);
                        break;
                    } catch (Exception e) {
                    }
                }
                if(fld!=null){
                    try {
                        Object v0 = fld.get(obj);
                        Object v1 = fld.get(obj1);
                        return v0.toString().compareTo(v1.toString());
                    } catch (Exception ex) {
                        return 0;
                    }
                } else {
                    return 0;
                }
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jList1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(jTable1);

        jSplitPane1.setRightComponent(jScrollPane2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
        try {
            Class cls = (Class) jList1.getSelectedValue();
            if (cls != null) {
                jTable1.setModel(createTable(cls));
                jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
            }
        } catch (Exception ex) {
            Logger.getLogger(WorkingMemoryInspector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jList1ValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
